package com.SoftWoehr.JTOpenContrib.MEU;

import java.beans.*;

public class MEUTextAreaBeanInfo extends SimpleBeanInfo {
            
  // Property identifiers //GEN-FIRST:Properties
  private static final int PROPERTY_peer = 0;
  private static final int PROPERTY_inputVerifier = 1;
  private static final int PROPERTY_verifyInputWhenFocusTarget = 2;
  private static final int PROPERTY_keymap = 3;
  private static final int PROPERTY_minimumSize = 4;
  private static final int PROPERTY_insets = 5;
  private static final int PROPERTY_tabSize = 6;
  private static final int PROPERTY_preferredSizeSet = 7;
  private static final int PROPERTY_disabledTextColor = 8;
  private static final int PROPERTY_preferredScrollableViewportSize = 9;
  private static final int PROPERTY_toolTipText = 10;
  private static final int PROPERTY_UIClassID = 11;
  private static final int PROPERTY_text = 12;
  private static final int PROPERTY_selectedText = 13;
  private static final int PROPERTY_preferredSize = 14;
  private static final int PROPERTY_class = 15;
  private static final int PROPERTY_cursor = 16;
  private static final int PROPERTY_paintingTile = 17;
  private static final int PROPERTY_enabled = 18;
  private static final int PROPERTY_focusTraversable = 19;
  private static final int PROPERTY_doubleBuffered = 20;
  private static final int PROPERTY_layout = 21;
  private static final int PROPERTY_toolkit = 22;
  private static final int PROPERTY_dropTarget = 23;
  private static final int PROPERTY_graphics = 24;
  private static final int PROPERTY_wrapStyleWord = 25;
  private static final int PROPERTY_name = 26;
  private static final int PROPERTY_parent = 27;
  private static final int PROPERTY_margin = 28;
  private static final int PROPERTY_y = 29;
  private static final int PROPERTY_x = 30;
  private static final int PROPERTY_treeLock = 31;
  private static final int PROPERTY_managingFocus = 32;
  private static final int PROPERTY_foreground = 33;
  private static final int PROPERTY_visible = 34;
  private static final int PROPERTY_lineWrap = 35;
  private static final int PROPERTY_components = 36;
  private static final int PROPERTY_actionMap = 37;
  private static final int PROPERTY_caret = 38;
  private static final int PROPERTY_accessibleContext = 39;
  private static final int PROPERTY_caretColor = 40;
  private static final int PROPERTY_UI = 41;
  private static final int PROPERTY_minimumSizeSet = 42;
  private static final int PROPERTY_document = 43;
  private static final int PROPERTY_selectedTextColor = 44;
  private static final int PROPERTY_focusAccelerator = 45;
  private static final int PROPERTY_caretPosition = 46;
  private static final int PROPERTY_maximumSizeSet = 47;
  private static final int PROPERTY_locale = 48;
  private static final int PROPERTY_background = 49;
  private static final int PROPERTY_bounds = 50;
  private static final int PROPERTY_columns = 51;
  private static final int PROPERTY_valid = 52;
  private static final int PROPERTY_autoscrolls = 53;
  private static final int PROPERTY_maximumSize = 54;
  private static final int PROPERTY_rootPane = 55;
  private static final int PROPERTY_lightweight = 56;
  private static final int PROPERTY_debugGraphicsOptions = 57;
  private static final int PROPERTY_highlighter = 58;
  private static final int PROPERTY_inputContext = 59;
  private static final int PROPERTY_colorModel = 60;
  private static final int PROPERTY_topLevelAncestor = 61;
  private static final int PROPERTY_opaque = 62;
  private static final int PROPERTY_componentCount = 63;
  private static final int PROPERTY_actions = 64;
  private static final int PROPERTY_optimizedDrawingEnabled = 65;
  private static final int PROPERTY_selectionColor = 66;
  private static final int PROPERTY_nextFocusableComponent = 67;
  private static final int PROPERTY_graphicsConfiguration = 68;
  private static final int PROPERTY_width = 69;
  private static final int PROPERTY_requestFocusEnabled = 70;
  private static final int PROPERTY_scrollableTracksViewportHeight = 71;
  private static final int PROPERTY_alignmentY = 72;
  private static final int PROPERTY_alignmentX = 73;
  private static final int PROPERTY_height = 74;
  private static final int PROPERTY_visibleRect = 75;
  private static final int PROPERTY_lineCount = 76;
  private static final int PROPERTY_validateRoot = 77;
  private static final int PROPERTY_showing = 78;
  private static final int PROPERTY_inputMethodRequests = 79;
  private static final int PROPERTY_font = 80;
  private static final int PROPERTY_scrollableTracksViewportWidth = 81;
  private static final int PROPERTY_border = 82;
  private static final int PROPERTY_componentOrientation = 83;
  private static final int PROPERTY_focusCycleRoot = 84;
  private static final int PROPERTY_editable = 85;
  private static final int PROPERTY_displayable = 86;
  private static final int PROPERTY_registeredKeyStrokes = 87;
  private static final int PROPERTY_locationOnScreen = 88;
  private static final int PROPERTY_selectionStart = 89;
  private static final int PROPERTY_rows = 90;
  private static final int PROPERTY_selectionEnd = 91;
  private static final int PROPERTY_lineStartOffset = 92;
  private static final int PROPERTY_lineEndOffset = 93;
  private static final int PROPERTY_lineOfOffset = 94;
  private static final int PROPERTY_component = 95;

  // Property array 
  private static PropertyDescriptor[] properties = new PropertyDescriptor[96];

  static {
    try {
      properties[PROPERTY_peer] = new PropertyDescriptor ( "peer", MEUTextArea.class, "getPeer", null );
      properties[PROPERTY_inputVerifier] = new PropertyDescriptor ( "inputVerifier", MEUTextArea.class, "getInputVerifier", "setInputVerifier" );
      properties[PROPERTY_verifyInputWhenFocusTarget] = new PropertyDescriptor ( "verifyInputWhenFocusTarget", MEUTextArea.class, "getVerifyInputWhenFocusTarget", "setVerifyInputWhenFocusTarget" );
      properties[PROPERTY_keymap] = new PropertyDescriptor ( "keymap", MEUTextArea.class, "getKeymap", "setKeymap" );
      properties[PROPERTY_minimumSize] = new PropertyDescriptor ( "minimumSize", MEUTextArea.class, "getMinimumSize", "setMinimumSize" );
      properties[PROPERTY_insets] = new PropertyDescriptor ( "insets", MEUTextArea.class, "getInsets", null );
      properties[PROPERTY_tabSize] = new PropertyDescriptor ( "tabSize", MEUTextArea.class, "getTabSize", "setTabSize" );
      properties[PROPERTY_preferredSizeSet] = new PropertyDescriptor ( "preferredSizeSet", MEUTextArea.class, "isPreferredSizeSet", null );
      properties[PROPERTY_disabledTextColor] = new PropertyDescriptor ( "disabledTextColor", MEUTextArea.class, "getDisabledTextColor", "setDisabledTextColor" );
      properties[PROPERTY_preferredScrollableViewportSize] = new PropertyDescriptor ( "preferredScrollableViewportSize", MEUTextArea.class, "getPreferredScrollableViewportSize", null );
      properties[PROPERTY_toolTipText] = new PropertyDescriptor ( "toolTipText", MEUTextArea.class, "getToolTipText", "setToolTipText" );
      properties[PROPERTY_UIClassID] = new PropertyDescriptor ( "UIClassID", MEUTextArea.class, "getUIClassID", null );
      properties[PROPERTY_text] = new PropertyDescriptor ( "text", MEUTextArea.class, "getText", null );
      properties[PROPERTY_selectedText] = new PropertyDescriptor ( "selectedText", MEUTextArea.class, "getSelectedText", null );
      properties[PROPERTY_preferredSize] = new PropertyDescriptor ( "preferredSize", MEUTextArea.class, "getPreferredSize", "setPreferredSize" );
      properties[PROPERTY_class] = new PropertyDescriptor ( "class", MEUTextArea.class, "getClass", null );
      properties[PROPERTY_cursor] = new PropertyDescriptor ( "cursor", MEUTextArea.class, "getCursor", "setCursor" );
      properties[PROPERTY_paintingTile] = new PropertyDescriptor ( "paintingTile", MEUTextArea.class, "isPaintingTile", null );
      properties[PROPERTY_enabled] = new PropertyDescriptor ( "enabled", MEUTextArea.class, "isEnabled", "setEnabled" );
      properties[PROPERTY_focusTraversable] = new PropertyDescriptor ( "focusTraversable", MEUTextArea.class, "isFocusTraversable", null );
      properties[PROPERTY_doubleBuffered] = new PropertyDescriptor ( "doubleBuffered", MEUTextArea.class, "isDoubleBuffered", "setDoubleBuffered" );
      properties[PROPERTY_layout] = new PropertyDescriptor ( "layout", MEUTextArea.class, "getLayout", "setLayout" );
      properties[PROPERTY_toolkit] = new PropertyDescriptor ( "toolkit", MEUTextArea.class, "getToolkit", null );
      properties[PROPERTY_dropTarget] = new PropertyDescriptor ( "dropTarget", MEUTextArea.class, "getDropTarget", "setDropTarget" );
      properties[PROPERTY_graphics] = new PropertyDescriptor ( "graphics", MEUTextArea.class, "getGraphics", null );
      properties[PROPERTY_wrapStyleWord] = new PropertyDescriptor ( "wrapStyleWord", MEUTextArea.class, "getWrapStyleWord", "setWrapStyleWord" );
      properties[PROPERTY_name] = new PropertyDescriptor ( "name", MEUTextArea.class, "getName", "setName" );
      properties[PROPERTY_parent] = new PropertyDescriptor ( "parent", MEUTextArea.class, "getParent", null );
      properties[PROPERTY_margin] = new PropertyDescriptor ( "margin", MEUTextArea.class, "getMargin", "setMargin" );
      properties[PROPERTY_y] = new PropertyDescriptor ( "y", MEUTextArea.class, "getY", null );
      properties[PROPERTY_x] = new PropertyDescriptor ( "x", MEUTextArea.class, "getX", null );
      properties[PROPERTY_treeLock] = new PropertyDescriptor ( "treeLock", MEUTextArea.class, "getTreeLock", null );
      properties[PROPERTY_managingFocus] = new PropertyDescriptor ( "managingFocus", MEUTextArea.class, "isManagingFocus", null );
      properties[PROPERTY_foreground] = new PropertyDescriptor ( "foreground", MEUTextArea.class, "getForeground", "setForeground" );
      properties[PROPERTY_visible] = new PropertyDescriptor ( "visible", MEUTextArea.class, "isVisible", "setVisible" );
      properties[PROPERTY_lineWrap] = new PropertyDescriptor ( "lineWrap", MEUTextArea.class, "getLineWrap", "setLineWrap" );
      properties[PROPERTY_components] = new PropertyDescriptor ( "components", MEUTextArea.class, "getComponents", null );
      properties[PROPERTY_actionMap] = new PropertyDescriptor ( "actionMap", MEUTextArea.class, "getActionMap", "setActionMap" );
      properties[PROPERTY_caret] = new PropertyDescriptor ( "caret", MEUTextArea.class, "getCaret", "setCaret" );
      properties[PROPERTY_accessibleContext] = new PropertyDescriptor ( "accessibleContext", MEUTextArea.class, "getAccessibleContext", null );
      properties[PROPERTY_caretColor] = new PropertyDescriptor ( "caretColor", MEUTextArea.class, "getCaretColor", "setCaretColor" );
      properties[PROPERTY_UI] = new PropertyDescriptor ( "UI", MEUTextArea.class, "getUI", "setUI" );
      properties[PROPERTY_minimumSizeSet] = new PropertyDescriptor ( "minimumSizeSet", MEUTextArea.class, "isMinimumSizeSet", null );
      properties[PROPERTY_document] = new PropertyDescriptor ( "document", MEUTextArea.class, "getDocument", "setDocument" );
      properties[PROPERTY_selectedTextColor] = new PropertyDescriptor ( "selectedTextColor", MEUTextArea.class, "getSelectedTextColor", "setSelectedTextColor" );
      properties[PROPERTY_focusAccelerator] = new PropertyDescriptor ( "focusAccelerator", MEUTextArea.class, "getFocusAccelerator", "setFocusAccelerator" );
      properties[PROPERTY_caretPosition] = new PropertyDescriptor ( "caretPosition", MEUTextArea.class, "getCaretPosition", "setCaretPosition" );
      properties[PROPERTY_maximumSizeSet] = new PropertyDescriptor ( "maximumSizeSet", MEUTextArea.class, "isMaximumSizeSet", null );
      properties[PROPERTY_locale] = new PropertyDescriptor ( "locale", MEUTextArea.class, "getLocale", "setLocale" );
      properties[PROPERTY_background] = new PropertyDescriptor ( "background", MEUTextArea.class, "getBackground", "setBackground" );
      properties[PROPERTY_bounds] = new PropertyDescriptor ( "bounds", MEUTextArea.class, "getBounds", "setBounds" );
      properties[PROPERTY_columns] = new PropertyDescriptor ( "columns", MEUTextArea.class, "getColumns", "setColumns" );
      properties[PROPERTY_valid] = new PropertyDescriptor ( "valid", MEUTextArea.class, "isValid", null );
      properties[PROPERTY_autoscrolls] = new PropertyDescriptor ( "autoscrolls", MEUTextArea.class, "getAutoscrolls", "setAutoscrolls" );
      properties[PROPERTY_maximumSize] = new PropertyDescriptor ( "maximumSize", MEUTextArea.class, "getMaximumSize", "setMaximumSize" );
      properties[PROPERTY_rootPane] = new PropertyDescriptor ( "rootPane", MEUTextArea.class, "getRootPane", null );
      properties[PROPERTY_lightweight] = new PropertyDescriptor ( "lightweight", MEUTextArea.class, "isLightweight", null );
      properties[PROPERTY_debugGraphicsOptions] = new PropertyDescriptor ( "debugGraphicsOptions", MEUTextArea.class, "getDebugGraphicsOptions", "setDebugGraphicsOptions" );
      properties[PROPERTY_highlighter] = new PropertyDescriptor ( "highlighter", MEUTextArea.class, "getHighlighter", "setHighlighter" );
      properties[PROPERTY_inputContext] = new PropertyDescriptor ( "inputContext", MEUTextArea.class, "getInputContext", null );
      properties[PROPERTY_colorModel] = new PropertyDescriptor ( "colorModel", MEUTextArea.class, "getColorModel", null );
      properties[PROPERTY_topLevelAncestor] = new PropertyDescriptor ( "topLevelAncestor", MEUTextArea.class, "getTopLevelAncestor", null );
      properties[PROPERTY_opaque] = new PropertyDescriptor ( "opaque", MEUTextArea.class, "isOpaque", "setOpaque" );
      properties[PROPERTY_componentCount] = new PropertyDescriptor ( "componentCount", MEUTextArea.class, "getComponentCount", null );
      properties[PROPERTY_actions] = new PropertyDescriptor ( "actions", MEUTextArea.class, "getActions", null );
      properties[PROPERTY_optimizedDrawingEnabled] = new PropertyDescriptor ( "optimizedDrawingEnabled", MEUTextArea.class, "isOptimizedDrawingEnabled", null );
      properties[PROPERTY_selectionColor] = new PropertyDescriptor ( "selectionColor", MEUTextArea.class, "getSelectionColor", "setSelectionColor" );
      properties[PROPERTY_nextFocusableComponent] = new PropertyDescriptor ( "nextFocusableComponent", MEUTextArea.class, "getNextFocusableComponent", "setNextFocusableComponent" );
      properties[PROPERTY_graphicsConfiguration] = new PropertyDescriptor ( "graphicsConfiguration", MEUTextArea.class, "getGraphicsConfiguration", null );
      properties[PROPERTY_width] = new PropertyDescriptor ( "width", MEUTextArea.class, "getWidth", null );
      properties[PROPERTY_requestFocusEnabled] = new PropertyDescriptor ( "requestFocusEnabled", MEUTextArea.class, "isRequestFocusEnabled", "setRequestFocusEnabled" );
      properties[PROPERTY_scrollableTracksViewportHeight] = new PropertyDescriptor ( "scrollableTracksViewportHeight", MEUTextArea.class, "getScrollableTracksViewportHeight", null );
      properties[PROPERTY_alignmentY] = new PropertyDescriptor ( "alignmentY", MEUTextArea.class, "getAlignmentY", "setAlignmentY" );
      properties[PROPERTY_alignmentX] = new PropertyDescriptor ( "alignmentX", MEUTextArea.class, "getAlignmentX", "setAlignmentX" );
      properties[PROPERTY_height] = new PropertyDescriptor ( "height", MEUTextArea.class, "getHeight", null );
      properties[PROPERTY_visibleRect] = new PropertyDescriptor ( "visibleRect", MEUTextArea.class, "getVisibleRect", null );
      properties[PROPERTY_lineCount] = new PropertyDescriptor ( "lineCount", MEUTextArea.class, "getLineCount", null );
      properties[PROPERTY_validateRoot] = new PropertyDescriptor ( "validateRoot", MEUTextArea.class, "isValidateRoot", null );
      properties[PROPERTY_showing] = new PropertyDescriptor ( "showing", MEUTextArea.class, "isShowing", null );
      properties[PROPERTY_inputMethodRequests] = new PropertyDescriptor ( "inputMethodRequests", MEUTextArea.class, "getInputMethodRequests", null );
      properties[PROPERTY_font] = new PropertyDescriptor ( "font", MEUTextArea.class, "getFont", "setFont" );
      properties[PROPERTY_scrollableTracksViewportWidth] = new PropertyDescriptor ( "scrollableTracksViewportWidth", MEUTextArea.class, "getScrollableTracksViewportWidth", null );
      properties[PROPERTY_border] = new PropertyDescriptor ( "border", MEUTextArea.class, "getBorder", "setBorder" );
      properties[PROPERTY_componentOrientation] = new PropertyDescriptor ( "componentOrientation", MEUTextArea.class, "getComponentOrientation", "setComponentOrientation" );
      properties[PROPERTY_focusCycleRoot] = new PropertyDescriptor ( "focusCycleRoot", MEUTextArea.class, "isFocusCycleRoot", null );
      properties[PROPERTY_editable] = new PropertyDescriptor ( "editable", MEUTextArea.class, "isEditable", "setEditable" );
      properties[PROPERTY_displayable] = new PropertyDescriptor ( "displayable", MEUTextArea.class, "isDisplayable", null );
      properties[PROPERTY_registeredKeyStrokes] = new PropertyDescriptor ( "registeredKeyStrokes", MEUTextArea.class, "getRegisteredKeyStrokes", null );
      properties[PROPERTY_locationOnScreen] = new PropertyDescriptor ( "locationOnScreen", MEUTextArea.class, "getLocationOnScreen", null );
      properties[PROPERTY_selectionStart] = new PropertyDescriptor ( "selectionStart", MEUTextArea.class, "getSelectionStart", "setSelectionStart" );
      properties[PROPERTY_rows] = new PropertyDescriptor ( "rows", MEUTextArea.class, "getRows", "setRows" );
      properties[PROPERTY_selectionEnd] = new PropertyDescriptor ( "selectionEnd", MEUTextArea.class, "getSelectionEnd", "setSelectionEnd" );
      properties[PROPERTY_lineStartOffset] = new IndexedPropertyDescriptor ( "lineStartOffset", MEUTextArea.class, null, null, "getLineStartOffset", null );
      properties[PROPERTY_lineEndOffset] = new IndexedPropertyDescriptor ( "lineEndOffset", MEUTextArea.class, null, null, "getLineEndOffset", null );
      properties[PROPERTY_lineOfOffset] = new IndexedPropertyDescriptor ( "lineOfOffset", MEUTextArea.class, null, null, "getLineOfOffset", null );
      properties[PROPERTY_component] = new IndexedPropertyDescriptor ( "component", MEUTextArea.class, null, null, "getComponent", null );
    }
    catch( IntrospectionException e) {}//GEN-HEADEREND:Properties
  
  // Here you can add code for customizing the properties array.  

}//GEN-LAST:Properties

  // EventSet identifiers//GEN-FIRST:Events
  private static final int EVENT_mouseMotionListener = 0;
  private static final int EVENT_inputMethodListener = 1;
  private static final int EVENT_ancestorListener = 2;
  private static final int EVENT_componentListener = 3;
  private static final int EVENT_hierarchyBoundsListener = 4;
  private static final int EVENT_mouseListener = 5;
  private static final int EVENT_focusListener = 6;
  private static final int EVENT_propertyChangeListener = 7;
  private static final int EVENT_keyListener = 8;
  private static final int EVENT_hierarchyListener = 9;
  private static final int EVENT_containerListener = 10;
  private static final int EVENT_vetoableChangeListener = 11;
  private static final int EVENT_caretListener = 12;

  // EventSet array
  private static EventSetDescriptor[] eventSets = new EventSetDescriptor[13];

  static {
    try {
      eventSets[EVENT_mouseMotionListener] = new EventSetDescriptor ( MEUTextArea.class, "mouseMotionListener", java.awt.event.MouseMotionListener.class, new String[0], "addMouseMotionListener", "removeMouseMotionListener" );
      eventSets[EVENT_inputMethodListener] = new EventSetDescriptor ( MEUTextArea.class, "inputMethodListener", java.awt.event.InputMethodListener.class, new String[0], "addInputMethodListener", "removeInputMethodListener" );
      eventSets[EVENT_ancestorListener] = new EventSetDescriptor ( MEUTextArea.class, "ancestorListener", javax.swing.event.AncestorListener.class, new String[0], "addAncestorListener", "removeAncestorListener" );
      eventSets[EVENT_componentListener] = new EventSetDescriptor ( MEUTextArea.class, "componentListener", java.awt.event.ComponentListener.class, new String[0], "addComponentListener", "removeComponentListener" );
      eventSets[EVENT_hierarchyBoundsListener] = new EventSetDescriptor ( MEUTextArea.class, "hierarchyBoundsListener", java.awt.event.HierarchyBoundsListener.class, new String[0], "addHierarchyBoundsListener", "removeHierarchyBoundsListener" );
      eventSets[EVENT_mouseListener] = new EventSetDescriptor ( MEUTextArea.class, "mouseListener", java.awt.event.MouseListener.class, new String[0], "addMouseListener", "removeMouseListener" );
      eventSets[EVENT_focusListener] = new EventSetDescriptor ( MEUTextArea.class, "focusListener", java.awt.event.FocusListener.class, new String[0], "addFocusListener", "removeFocusListener" );
      eventSets[EVENT_propertyChangeListener] = new EventSetDescriptor ( MEUTextArea.class, "propertyChangeListener", java.beans.PropertyChangeListener.class, new String[0], "addPropertyChangeListener", "removePropertyChangeListener" );
      eventSets[EVENT_keyListener] = new EventSetDescriptor ( MEUTextArea.class, "keyListener", java.awt.event.KeyListener.class, new String[0], "addKeyListener", "removeKeyListener" );
      eventSets[EVENT_hierarchyListener] = new EventSetDescriptor ( MEUTextArea.class, "hierarchyListener", java.awt.event.HierarchyListener.class, new String[0], "addHierarchyListener", "removeHierarchyListener" );
      eventSets[EVENT_containerListener] = new EventSetDescriptor ( MEUTextArea.class, "containerListener", java.awt.event.ContainerListener.class, new String[0], "addContainerListener", "removeContainerListener" );
      eventSets[EVENT_vetoableChangeListener] = new EventSetDescriptor ( MEUTextArea.class, "vetoableChangeListener", java.beans.VetoableChangeListener.class, new String[0], "addVetoableChangeListener", "removeVetoableChangeListener" );
      eventSets[EVENT_caretListener] = new EventSetDescriptor ( MEUTextArea.class, "caretListener", javax.swing.event.CaretListener.class, new String[0], "addCaretListener", "removeCaretListener" );
    }
    catch( IntrospectionException e) {}//GEN-HEADEREND:Events

  // Here you can add code for customizing the event sets array.  

}//GEN-LAST:Events

  private static java.awt.Image iconColor16 = null; //GEN-BEGIN:IconsDef
  private static java.awt.Image iconColor32 = null;
  private static java.awt.Image iconMono16 = null;
  private static java.awt.Image iconMono32 = null; //GEN-END:IconsDef
  private static String iconNameC16 = null;//GEN-BEGIN:Icons
  private static String iconNameC32 = null;
  private static String iconNameM16 = null;
  private static String iconNameM32 = null;//GEN-END:Icons
                                                 
  private static int defaultPropertyIndex = -1;//GEN-BEGIN:Idx
  private static int defaultEventIndex = -1;//GEN-END:Idx


  /**
   * Gets the beans <code>PropertyDescriptor</code>s.
   * 
   * @return An array of PropertyDescriptors describing the editable
   * properties supported by this bean.  May return null if the
   * information should be obtained by automatic analysis.
   * <p>
   * If a property is indexed, then its entry in the result array will
   * belong to the IndexedPropertyDescriptor subclass of PropertyDescriptor.
   * A client of getPropertyDescriptors can use "instanceof" to check
   * if a given PropertyDescriptor is an IndexedPropertyDescriptor.
   */
  public PropertyDescriptor[] getPropertyDescriptors() {
    return properties;
  }

  /**
   * Gets the beans <code>EventSetDescriptor</code>s.
   * 
   * @return  An array of EventSetDescriptors describing the kinds of 
   * events fired by this bean.  May return null if the information
   * should be obtained by automatic analysis.
   */
  public EventSetDescriptor[] getEventSetDescriptors() {
    return eventSets;
  }

  /**
   * A bean may have a "default" property that is the property that will
   * mostly commonly be initially chosen for update by human's who are 
   * customizing the bean.
   * @return  Index of default property in the PropertyDescriptor array
   * 		returned by getPropertyDescriptors.
   * <P>	Returns -1 if there is no default property.
   */
  public int getDefaultPropertyIndex() {
    return defaultPropertyIndex;
  }

  /**
   * A bean may have a "default" event that is the event that will
   * mostly commonly be used by human's when using the bean. 
   * @return Index of default event in the EventSetDescriptor array
   *		returned by getEventSetDescriptors.
   * <P>	Returns -1 if there is no default event.
   */
  public int getDefaultEventIndex() {
    return defaultPropertyIndex;
  }

  /**
   * This method returns an image object that can be used to
   * represent the bean in toolboxes, toolbars, etc.   Icon images
   * will typically be GIFs, but may in future include other formats.
   * <p>
   * Beans aren't required to provide icons and may return null from
   * this method.
   * <p>
   * There are four possible flavors of icons (16x16 color,
   * 32x32 color, 16x16 mono, 32x32 mono).  If a bean choses to only
   * support a single icon we recommend supporting 16x16 color.
   * <p>
   * We recommend that icons have a "transparent" background
   * so they can be rendered onto an existing background.
   *
   * @param  iconKind  The kind of icon requested.  This should be
   *    one of the constant values ICON_COLOR_16x16, ICON_COLOR_32x32, 
   *    ICON_MONO_16x16, or ICON_MONO_32x32.
   * @return  An image object representing the requested icon.  May
   *    return null if no suitable icon is available.
   */
  public java.awt.Image getIcon(int iconKind) {
    switch ( iconKind ) {
      case ICON_COLOR_16x16:
        if ( iconNameC16 == null )
          return null;
        else {
          if( iconColor16 == null )
            iconColor16 = loadImage( iconNameC16 );
          return iconColor16;
          }
      case ICON_COLOR_32x32:
        if ( iconNameC32 == null )
          return null;
        else {
          if( iconColor32 == null )
            iconColor32 = loadImage( iconNameC32 );
          return iconColor32;
          }
      case ICON_MONO_16x16:
        if ( iconNameM16 == null )
          return null;
        else {
          if( iconMono16 == null )
            iconMono16 = loadImage( iconNameM16 );
          return iconMono16;
          }
      case ICON_MONO_32x32:
        if ( iconNameM32 == null )
          return null;
        else {
          if( iconNameM32 == null )
            iconMono32 = loadImage( iconNameM32 );
          return iconMono32;
          }
    }
    return null;
  }

}
