/*
 * QCStockDialog.java
 *
 * Created on August 25, 2000, 9:35 PM
 */

package com.SoftWoehr.JTOpenContrib.QCDemo;

/** Static methods to show dialogs.
 * @author jax
 * @version 1.1
 */
public class QCStockDialog extends Object {

  /** Creates new QCStockDialog */
  protected QCStockDialog() {
  }

  /** Warn user that server is not set */
  public static void showNoServerDialog() {
    javax.swing.JOptionPane.showMessageDialog
    (null, "You must set system name first.", "No server specified", javax.swing.JOptionPane.WARNING_MESSAGE);
  }
  
  /** A dialog indicating that a field entry is invalid.
   * @param fieldName Name of field with invalid entry.
   * @param value The invalid entry
   */
  public static void showFieldEntryInvalidDialog(String fieldName,String value) {
    javax.swing.JOptionPane.showMessageDialog
    (null, "The value " + value + " in the " + fieldName + " field is not valid.", "Invalid value entered", javax.swing.JOptionPane.WARNING_MESSAGE);
  }
}